//+------------------------------------------------------------------+
//|                                                    DiNapoli MACD |
//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  MediumVioletRed
#property indicator_color2  MediumVioletRed
#property indicator_color3  LimeGreen
#property indicator_color4  LimeGreen
#property indicator_color5  DimGray
#property indicator_color6  Gold
#property indicator_width2  2
#property indicator_width4  2
#property indicator_width5  1
#property indicator_width6  3

//
//
//
//
//

extern double FastPeriod      =  8.3896;
extern double SlowPeriod      = 17.5185;
extern double SignalPeriod    =  9.0503;
extern int    Price           = PRICE_CLOSE;
//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer5[];
double buffer6[];
double trend[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorDigits(6);
   IndicatorBuffers(7);
   SetIndexBuffer(0,buffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,buffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,buffer3); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,buffer4); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,buffer5);
   SetIndexBuffer(5,buffer6);
   SetIndexBuffer(6,trend);
      FastPeriod   = MathMax(FastPeriod,1);
      SlowPeriod   = MathMax(SlowPeriod,1);
      SignalPeriod = MathMax(SignalPeriod,1);
   IndicatorShortName("DiNapoli MACD ("+DoubleToStr(FastPeriod,4)+","+DoubleToStr(SlowPeriod,4)+","+DoubleToStr(SignalPeriod,4)+","+")");
}

//
//
//
//
//

int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][3];

#define _ema1 0
#define _ema2 1

int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (ArrayRange(work,0)!= Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //

      double alpha1 = 2.0/(1.0+FastPeriod);
      double alpha2 = 2.0/(1.0+SlowPeriod);
      double alpha3 = 2.0/(1.0+SignalPeriod);
      for(i=limit,r=Bars-i-1; i>=0; i--,r++)
      {
         double price = iMA(NULL,0,1,0,MODE_SMA,Price,i);
            if (r==0)
            {
               work[r][_ema1] = price;
               work[r][_ema2] = price;
               buffer6[i]     = 0;
               continue;
            }               
         
         //
         //
         //
         //
         //
         
         work[r][_ema1] = work[r-1][_ema1]+alpha1*(price-work[r-1][_ema1]);
         work[r][_ema2] = work[r-1][_ema2]+alpha2*(price-work[r-1][_ema2]);
         
            buffer5[i] = work[r][_ema1]-work[r][_ema2];
            buffer6[i] = buffer6[i+1]+alpha3*(buffer5[i]-buffer6[i+1]);
            buffer1[i] = EMPTY_VALUE;
            buffer2[i] = EMPTY_VALUE;
            buffer3[i] = EMPTY_VALUE;
            buffer4[i] = EMPTY_VALUE;
            trend[i]   = trend[i+1];
         
            //
            //
            //
            //
            //
            
            if (buffer5[i]>buffer5[i+1]) trend[i] =  1;
            if (buffer5[i]<buffer5[i+1]) trend[i] = -1;
            if (buffer5[i]>0)
            {
               if (trend[i] ==  1) { buffer4[i] = buffer5[i]; }
               if (trend[i] == -1) { buffer3[i] = buffer5[i]; }
            }
            if (buffer5[i]<0)
            {
               if (trend[i] ==  1) { buffer1[i] = buffer5[i]; }
               if (trend[i] == -1) { buffer2[i] = buffer5[i]; }
            }
      }            
      return(0);
}

